boolean findDesignIntersect(float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, boolean showIntesectionLines, boolean drawDesignDots, boolean numberDesignDots, char caseLetter) {
  // calculate the intersection between 2 non-parallel lines
  intersect = false;

  a1 = y2 - y1;
  b1 = x1 - x2;
  c1 = a1*x1 + b1*y1;
  a2 = y4 - y3;
  b2 = x3 - x4;
  c2 = a2*x3 + b2*y3;
  det = a1*b2 - a2*b1;

  if (det == 0) {
    // Lines are parallel
  } else {
    x = (b2*c1 - b1*c2)/det;  // set global variables intersection point x coordinate
    y = (a1*c2 - a2*c1)/det;  // set global variables intersection point y coordinate

    if (x > min(x1, x2) && x < max(x1, x2) &&
      x > min(x3, x4) && x < max(x3, x4) &&
      y > min(y1, y2) && y < max(y1, y2) &&
      y > min(y3, y4) && y < max(y3, y4)) {
      intersect = true;
    }
  }

  // if true then trace intersecting lines in blue
  if (showIntesectionLines) {
    strokeWeight(2);
    noFill();
    stroke(0, 0, 255); // blue
    line(x1, y1, x2, y2);
    line(x3, y3, x4, y4);
    ellipse(x, y, 10, 10);
  }

  // if true then draw design dot
  if (drawDesignDots) {
    strokeWeight(2);
    stroke(srrr, sggg, sbbb); // Design line colour
    fill(srrr, sggg, sbbb); // Design line colour
    ellipse(x, y, 10, 10);
  }

  // save points
  switch (caseLetter) {
  case'A':
    xDesignLinesInStep13[Step13Counter] = x;
    yDesignLinesInStep13[Step13Counter] = y;
    // if true then number design dot
    if (numberDesignDots) { // numberDesignDots
      strokeWeight(2);
      stroke(srrr, sggg, sbbb); // Design line colour
      text(Step13Counter, x + xOffset * 1.5, y + yOffset *1.5);
    }
    Step13Counter ++; // track which array cell to save into
    break;
  case'B':
    xDesignLinesInStep14[Step14Counter] = x;
    yDesignLinesInStep14[Step14Counter] = y;
    // if true then number design dot
    if (numberDesignDots) { // numberDesignDots
      strokeWeight(2);
      stroke(srrr, sggg, sbbb); // Design line colour
      text(Step14Counter, x + xOffset * 1.5, y + yOffset *1.5);
    }
    Step14Counter ++; // track which array cell to save into
    break;
    
     case'C':
    xDesignLinesInStep15[Step15Counter] = x;
    yDesignLinesInStep15[Step15Counter] = y;
    // if true then number design dot
    if (numberDesignDots) { // numberDesignDots
      strokeWeight(2);
      stroke(srrr, sggg, sbbb); // Design line colour
      text(Step15Counter, x + xOffset * 1.5, y + yOffset *1.5);
    }
    Step15Counter ++; // track which array cell to save into
    break; 
    
    
  default:
    println("error in case in findDesignIntersect");
    exit();
    break;
  }

  return intersect; // retun true if the line interesetc
}
